REM
REM AT17Cxxx Programmer
REM Author: Ingo Cyliax, EZComm Consulting, cyliax@EZComm.com
REM Date: Nov 23, 1995
REM
DECLARE FUNCTION reverse! (xbits!)
DECLARE FUNCTION atoh2! (s$)
DECLARE FUNCTION atoh! (s$)
DECLARE FUNCTION atoh4! (s$)
DECLARE FUNCTION done! ()
DECLARE FUNCTION writebyte! (b!)
DECLARE FUNCTION cndstop! ()
DECLARE FUNCTION cndstart! ()
DECLARE FUNCTION readbyte! ()
DECLARE FUNCTION readbit! ()
DECLARE FUNCTION writebit! (bit!)
DECLARE FUNCTION init! ()

DIM pdat(4096)

PRINT "Initializing..."
x = init
PRINT "Reading..."
x = cndstart
x = writebyte(&HA6)
x = writebyte(&H0)
x = writebyte(&H0)
x = cndstart
x = writebyte(&HA7)
FOR i = 0 TO 4095
        pdat(i) = readbyte
NEXT i
x = cndstop

PRINT "Enter File: ";
LINE INPUT file$

PRINT "Reading file..."
OPEN file$ FOR INPUT AS #1
WHILE NOT EOF(1)
LINE INPUT #1, a$

IF MID$(a$, 1, 2) = "S1" THEN
        hlen = atoh2(MID$(a$, 3, 2))
        haddr = atoh4(MID$(a$, 5, 4))
REM        PRINT a$
REM        PRINT "len:"; hlen
REM        PRINT "addr:"; haddr
        FOR i = 0 TO hlen - 3 - 1
REM                PRINT MID$(a$, i * 2 + 9, 2);
                pdat(haddr) = reverse(atoh2(MID$(a$, i * 2 + 9, 2)))
                haddr = haddr + 1
                IF haddr > maxaddr THEN maxaddr = haddr
        NEXT i
REM        PRINT
END IF
WEND

PRINT "maxaddr", maxaddr

PRINT "Programming..."
paddr = 0
WHILE paddr < maxaddr
        x = 1
        WHILE x = 1
                x = cndstart
                x = writebyte(&HA6)
                IF x = 1 THEN PRINT ".";
        WEND
        x = writebyte(INT(paddr / 256))
        x = writebyte(paddr MOD 256)
        FOR i = 1 TO 64
                x = writebyte(pdat(paddr))
                paddr = paddr + 1
        NEXT i
        x = cndstop
WEND
PRINT


PRINT "Verifying..."
x = cndstart
x = writebyte(&HA6)
x = writebyte(&H0)
x = writebyte(&H0)
x = cndstart
x = writebyte(&HA7)
FOR i = 0 TO maxaddr
        IF pdat(i) <> readbyte THEN
                PRINT "Verify failed at addr"; i
        END IF
NEXT i

x = done
STOP

FUNCTION atoh (s$)
        IF ASC(s$) >= ASC("0") AND ASC(s$) <= ASC("9") THEN
                atoh = ASC(s$) - ASC("0")
        ELSEIF ASC(s$) >= ASC("a") AND ASC(s$) <= ASC("f") THEN
                atoh = ASC(s$) - ASC("a") + 10
        ELSEIF ASC(s$) >= ASC("A") AND ASC(s$) <= ASC("F") THEN
                atoh = ASC(s$) - ASC("A") + 10
        ELSE
                atoh = 0
        END IF
END FUNCTION

FUNCTION atoh2 (s$)
        x = atoh(MID$(s$, 1, 1))
        x = x * 16
        x = x + atoh(MID$(s$, 2, 1))
        atoh2 = x
END FUNCTION

FUNCTION atoh4 (s$)
        x = atoh2(MID$(s$, 1, 2))
        x = x * 256
        x = x + atoh2(MID$(s$, 3, 2))
        atoh4 = x
END FUNCTION

FUNCTION cndstart
        OUT &H378, &HC3
        OUT &H378, &HC3
        OUT &H378, &HC2
        OUT &H378, &HC2
        OUT &H378, &HC0
        OUT &H378, &HC1
        OUT &H378, &HC1
END FUNCTION

FUNCTION cndstop
        OUT &H378, &HC0
        OUT &H378, &HC0
        OUT &H378, &HC2
        OUT &H378, &HC2
        OUT &H378, &HC3
        OUT &H378, &HC3
        OUT &H378, &HC1
        OUT &H378, &HC1
END FUNCTION

FUNCTION done
        OUT &H378, &H0
END FUNCTION

FUNCTION init
        OUT &H378, &HC1
        OUT &H378, &HC1
        SLEEP 1
END FUNCTION

FUNCTION readbit
        OUT &H378, &HC3
        OUT &H378, &HC3
        a = INT(INP(&H379) / 16)
        a = a MOD 2
        OUT &H378, &HC1
        OUT &H378, &HC1
        readbit = a
END FUNCTION

FUNCTION readbyte
        x = 0
        FOR i = 1 TO 8
                b = readbit
                x = x * 2 + b
        NEXT i
        b = writebit(0)
        readbyte = x
END FUNCTION

FUNCTION reverse (xbits)
        ybits = 0
        FOR i = 0 TO 7
                ybits = 2 * ybits + (INT(xbits / (2 ^ i)) MOD 2)
        NEXT i
        reverse = ybits
END FUNCTION

FUNCTION writebit (bit)
        OUT &H378, &HC0 + bit
        OUT &H378, &HC0 + bit
        OUT &H378, &HC2 + bit
        OUT &H378, &HC2 + bit
        OUT &H378, &HC0 + bit
        OUT &H378, &HC0 + bit
        OUT &H378, &HC1
        OUT &H378, &HC1
END FUNCTION

FUNCTION writebyte (b)
        FOR i = 1 TO 8
                a = INT(b / (2 ^ (8 - i)))
                a = a MOD 2
                x = writebit(a)
        NEXT i
        a = readbit
        writebyte = a
END FUNCTION

